Name:           ulogd
Version:        1.24
Release:        9%{?dist}
Summary:        The userspace logging daemon for netfilter
License:        GPLv2
Group:          System Environment/Daemons
URL:            http://gnumonks.org/projects
Source0:        http://ftp.netfilter.org/pub/ulogd/ulogd-%{version}.tar.bz2
Source1:        ulogd.logrotate
Source2:        ulogd.8
Patch1:         ulogd-1.21-logdir.patch
Patch2:         ulogd-1.02-init.patch
# Bug 247345
Patch3:         ulogd-1.24-fortify-source.patch
# The code uses a deprecated way of getting its DSO initializers run,
# build fails with rpm-build > 4.4.2.1-3 (new find-debuginfo.sh script)
Patch4:         ulogd-1.24-initializers.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires(post):	initscripts, chkconfig
Requires(postun): initscripts, chkconfig
BuildRequires:  mysql-devel
BuildRequires:  postgresql-devel
BuildRequires:	libpcap-devel
BuildRequires:	openssl-devel

%description
Ulogd is an universal logging daemon for the ULOG target of netfilter, the
Linux 2.4+ firewalling subsystem. Ulogd is able to log packets in various
formats to different targets (text files, databases, etc..). It has an
easy-to-use plugin interface to add new protocols and new output targets.

%package mysql
Summary:        MySQL output plugin for ulogd
Group:          System Environment/Daemons
Requires:       %{name} = %{version}

%description mysql
Ulogd-mysql is a MySQL output plugin for ulogd. It enables logging of
firewall information into a MySQL database.
                                                                                
%package pgsql
Summary:        PostgreSQL output plugin for ulogd
Group:          System Environment/Daemons
Requires:       %{name} = %{version}

%description pgsql
Ulogd-pgsql is a PostgreSQL output plugin for ulogd. It enables logging of
firewall information into a PostgreSQL database.

%package pcap
Summary:        PCAP output plugin for ulogd
Group:          System Environment/Daemons
Requires:       %{name} = %{version}

%description pcap
ulogd-pcap is a output plugin for ulogd that saves packet logs as PCAP file.
PCAP is a standard format that can be later analyzed by a lot of tools such as
tcpdump and wireshark.


%prep
%setup -q
%patch1 -p1 -b .logdir
%patch2 -p1 -b .lsbinit
%patch3 -p0 -b .fortify-source
# Enable BuildID :
# https://www.redhat.com/archives/fedora-devel-announce/2007-August/msg00007.html
perl -pi -e 's/\(LD\) -shared/(CC) \$(CFLAGS) \$(LDFLAGS) -shared/g' */Makefile.in
%patch4 -p1 -b .initializers


%build
%configure --with-mysql --with-pgsql
# Does not support parallel builds
make 

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}
mkdir -p $RPM_BUILD_ROOT%{_libdir}/ulogd
mkdir -p $RPM_BUILD_ROOT%{_sbindir}/sbin
make DESTDIR=$RPM_BUILD_ROOT install

mkdir -p $RPM_BUILD_ROOT%{_initrddir}
install -m755 ulogd.init $RPM_BUILD_ROOT%{_initrddir}/ulogd

mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/log/ulogd

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d
install -m644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/ulogd

mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8
sed -e 's/@VERSION@/%{version}/g' %{SOURCE2} > $RPM_BUILD_ROOT%{_mandir}/man8/ulogd.8
gzip $RPM_BUILD_ROOT%{_mandir}/man8/ulogd.8


%post
/sbin/chkconfig --add ulogd

%preun 
if [ "$1" = 0 ]; then 
  /sbin/service ulogd stop > /dev/null 2>&1 ||:
  /sbin/chkconfig --del ulogd 
fi

%postun 
if [ "$1" -ge "1" ]; then 
  /sbin/service ulogd reload > /dev/null 2>&1 ||:
fi


%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,)
%doc COPYING AUTHORS README
%doc doc/ulogd.txt doc/ulogd.a4.ps doc/ulogd.html
%doc doc/mysql.table* doc/pgsql.table
%{_sbindir}/ulogd
%config(noreplace) %{_sysconfdir}/ulogd.conf
%{_sysconfdir}/rc.d/init.d/ulogd
%{_libdir}/ulogd
%dir %{_localstatedir}/log/ulogd
%config(noreplace) %{_sysconfdir}/logrotate.d/ulogd
%{_mandir}/man8/ulogd.8.gz
%exclude %{_libdir}/ulogd/ulogd_MYSQL.so
%exclude %{_libdir}/ulogd/ulogd_PGSQL.so
%exclude %{_libdir}/ulogd/ulogd_PCAP.so

%files mysql
%defattr(0755,root,root)
%{_libdir}/ulogd/ulogd_MYSQL.so

%files pgsql
%defattr(0755,root,root)
%{_libdir}/ulogd/ulogd_PGSQL.so

%files pcap
%defattr(0755,root,root)
%{_libdir}/ulogd/ulogd_PCAP.so

%changelog
* Mon Feb 18 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 1.24-9
- Autorebuild for GCC 4.3

* Wed Jan 9 2008 Leopold Aichinger <linuxtrainer@gmx.at> 1.24-8
- Support for libpcap added

* Thu Dec 06 2007 Release Engineering <rel-eng at fedoraproject dot org> - 1.24-7
- Rebuild for deps

* Tue Aug 14 2007 Aurelien Bompard <abompard@fedoraproject.org> 1.24-5
- Fix the deprecated way of getting the DSO initializers run, causing
  builds to fails with rpm-build > 4.4.2.1-3 (new find-debuginfo.sh script)

* Sat Jul 14 2007 Aurelien Bompard <abompard@fedoraproject.org> 1.24-4
- add patch to fix bug 247345
- update URL
- fix initscript (bug 247083)
- unmark init script as %%config (Fedora policy)

* Sat Dec 09 2006 Aurelien Bompard <abompard@fedoraproject.org> 1.24-3
- rebuild

* Thu Aug 31 2006 Aurelien Bompard <abompard@fedoraproject.org> 1.24-2
- rebuild

* Wed Feb 22 2006 Aurelien Bompard <gauret[AT]free.fr> 1.24-1
- version 1.24
- drop patch3 (applied upstream)
- drop patch4 (upstream uses mysql-config to detect libdir now)
- drop patch5 (applied upstream)

* Tue Feb 21 2006 Aurelien Bompard <gauret[AT]free.fr> 1.23-3
- rebuild for FC5

* Sun Jul 24 2005 Aurelien Bompard <gauret[AT]free.fr> 1.23-2
- compress rotated logs
- start after mysql in the init process
- use dist tag

* Tue Apr 19 2005 Aurelien Bompard <gauret[AT]free.fr> 1.23-1.fc4
- version 1.23
- change release tag for FC4
- add patch for GCC4 (upstream bug #323)

* Fri Apr  7 2005 Michael Schwendt <mschwendt[AT]users.sf.net>
- rebuilt

* Wed Mar 09 2005 Aurelien Bompard <gauret[AT]free.fr> 1.22-1
- version 1.22
- add gpg signature to sources

* Sun Feb 20 2005 Aurelien Bompard <gauret[AT]free.fr> 1.21-1
- version 1.21

* Fri Dec 17 2004 Michael Schwendt <mschwendt[AT]users.sf.net> 1.02-8
- revise x86_64 patch to remove more hardcoded /lib badness

* Fri Dec 17 2004 Michael Schwendt <mschwendt[AT]users.sf.net> 1.02-7
- x86_64, patch configure to look for mysql/pgsql below %%_libdir.
- delete undefined %%epoch in mysql/pgsql sub package dep.

* Sun Oct 31 2004 Aurelien Bompard <gauret[AT]free.fr> 1.02-6
- apply Michael Schwendt's suggestions in bug 1598

* Wed Oct 20 2004 Aurelien Bompard <gauret[AT]free.fr> 0:1.02-0.fdr.5
- enable MySQL and PostgreSQL in subpackages
- add man page from Debian

* Wed Oct 06 2004 Aurelien Bompard <gauret[AT]free.fr> 0:1.02-0.fdr.4
- apply QA suggestions (bug 1598)

* Sat Jul 10 2004 Aurelien Bompard <gauret[AT]free.fr> 0:1.02-0.fdr.3
- disable parallel builds
- add chkconfig to Requires(pre,post)
- set the right mode for /etc/logrotate.d/ulogd
- rotate weekly

* Sun May 16 2004 Aurelien Bompard <gauret[AT]free.fr> 0:1.02-0.fdr.2
- Add Epoch: 0
